=== debian/changelog ===
86box (5.1) UNRELEASED; urgency=medium

  * Bump release.

 -- Jasmine Iwanek <jriwanek@gmail.com>  Wed, 27 Aug 2025 19:39:16 +0200
